
{$APPTYPE GUI}{$MODE DELPHI}

program Demo23;

uses
  SysUtils,windows,math,gl,glu,GraphOGL;

//const 

//type
  
var
  specchio:array[0..10]of gluint;
  angx,angy:glfloat;  
  temp:array[0..5000]of TGLVector;
  RndPos:array[0..5000]of glFloat;
  RndRot:array[0..5000]of glFloat;
  RndSize:array[0..5000]of glFloat;
  i,MaxGrass:integer;  
  
{$i erba00.inc} 
{$i felce01.inc}   
{$i Cespuglio01.inc}  
 
procedure Quad(x1,y1,z1,x2,y2,z2,x3,y3,z3,x4,y4,z4,tsize:glFloat);
begin
  glBegin(GL_QUADS);
   FindNormal(x2,y2,z2,x1,y1,z1,x3,y3,z3);
   glNormal3f(FNormal[1], FNormal[2], FNormal[3]);
	LineFree(tsize,tsize, 0,tsize, x2,y2,z2, x1,y1,z1,true);
	LineFree(0,0, tsize,0, x3,y3,z3, x4,y4,z4,true);	
  glEnd;
end; 
 
  
procedure InitGrass(NumObj,dist:integer;h:glFloat);
begin 
  MaxGrass:=NumObj;
  
  for i:=0 to MaxGrass do
  begin
    temp[i].x:=dist-random(dist*2);
	temp[i].y:=h;	
    temp[i].z:=dist-random(dist*2);
    RndPos[i]:=randomf(0.5);
    RndRot[i]:=180-random(360);
    RndSize[i]:=1-randomf(0.5);	 
  end;  
end;

procedure PutGrass;
begin
  for i:=0 to MaxGrass do
  begin
      begin
        if(RndPos[i]<0.15)then
        begin
		  glPushMatrix;
          glTranslatef(temp[i].x,temp[i].y,temp[i].z);       
          glRotatef(RndRot[i],0,1,0);
          glScalef(RndSize[i],RndSize[i],RndSize[i]);	
          glScalef(0.2,0.2,0.2);				 
		    felce01;          
		  glPopMatrix;                
        end else
		if(RndPos[i]>0.3)then
        begin
		  TextureSelectID(0);
		  glPushMatrix;
          glTranslatef(temp[i].x,temp[i].y,temp[i].z);       
          glRotatef(RndRot[i],0,1,0);
			 glScalef(RndSize[i],RndSize[i],RndSize[i]);		 
          erba00;
          glPopMatrix;				
        end else		
        begin
		  TextureSelectID(0);
		  glPushMatrix;
          glTranslatef(temp[i].x,temp[i].y,temp[i].z);       
          glRotatef(RndRot[i],0,1,0);	
			 glScalef(RndSize[i],RndSize[i],RndSize[i]);
          glScalef(0.35,0.35,0.35);			 
		    Cespuglio01;
          glPopMatrix;				
        end;		
      end;
    end;	  
end; 
 
 
procedure Scena;
begin  
  PutglPointLight(GL_LIGHT0,0,8,8,12,0.1);  

  TextureSelectID(0);
  Quad(10,0,10, -10,0,10, 10,0,-10, -10,0,-10, 3);
  
  TextureSelectID(1);    
  cubo(0,0,0, -0.5,0,-0.5, 0.5,1.5,0.5, 1);  
  
  TextureSelectID(2);
  glPushMatrix;  
  glTranslatef(0,2.5,-4);
  glRotatef(angx,1,0,0);  
  glRotatef(angy,0,1,0);  
  Disco(0,0,-0.09, 20,2.5); 
  //Cono(0,0,-0.09, 20,2.5,0);  
  Toroide(0,0,0, 0.1,2.5, 20,32);  
  glPopMatrix;  
  
  PutGrass;  
   
end; 
 
 
procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin  
	
  TextureLoadID('gras.bmp',0);
  TextureLoadID('Floor02.bmp',1);  
  TextureLoadID('wood26.bmp',2);
  
  TextureLoadTGAID('erba00.tga',0);
	
end;
begin     
   
  OpenGL_Texture();

  InitText(0,0,0,0);   
   
  specchio[0] := glGenLists(1);
  glNewList(specchio[0],GL_COMPILE); 
  TextureOFF; 
  Disco2(0,0,0, 20,2.5); 
  TextureON;
  glEndList();    
   
  erba00_;
  felce01_;
  Cespuglio01_;
	
  InitGrass(30,10,0);	   
   
end; 


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);               // inizializza la grafica 2D     

  OpenGL_Init(1000,0.0,0.0,0.0,0.0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin     
   
  if SetglKey(VK_UP)then angx:=angx-2.5;
  if SetglKey(VK_DOWN)then angx:=angx+2.5;		
  if SetglKey(VK_LEFT)then angy:=angy-2.5;
  if SetglKey(VK_RIGHT)then angy:=angy+2.5;	
	
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
   
  glTranslatef(0,-5,-22);       // regola l'inquadratura degli elementi nello schermo    
  glRotatef(0,0,0,0);          // regola l'inquadratura di n gradi rispetto agli assi x y z 
  
  SetglMouseMove(GL_M0,2);  
      
  FX_Mirror(0,2.5,-0.05-4, angx,angy,0,specchio[0],Scena,true); 
  
end;

// inizio del programma
begin

 //if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
 //then fullscreen := false else fullscreen := true;

 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Esempio di uno specchio', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(1000,0.0,0.0,0.0,0.0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteglText;
 DeleteOGLWindow();		    // chiude la finestra
end.
